-- Auch an Quests, AH, etc. (also Freitext!) erinnern

RefillRemind = LibStub("AceAddon-3.0"):NewAddon("RefillRemind", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
LibStub("AceAddon-3.0"):EmbedLibrary(RefillRemind, "LibFuBarPlugin-3.0", true)

local RefillRemind = RefillRemind
local L = LibStub("AceLocale-3.0"):GetLocale("RefillRemind")

local PT = AceLibrary("LibPeriodicTable-3.1")
local Tourist = Rock("LibTourist-3.0")

local MAX_THRESHOLD = 100
local MAX_INTERVAL = 300

-- Got this from FuBar_PTReagents
local additionalSets = {
	WARLOCK = {"Consumable.Warlock.Healthstone", "Consumable.Warlock.Spellstone", "Consumable.Warlock.Soulstone", "Consumable.Warlock.Firestone"},
	ROGUE = {"Consumable.Potion.Other.Energy", "Consumable.Weapon Buff.Poison.Anesthetic", "Consumable.Weapon Buff.Poison.Wound", "Consumable.Weapon Buff.Poison.Mind Numbing", "Consumable.Weapon Buff.Poison.Instant", "Consumable.Weapon Buff.Poison.Crippling", "Consumable.Weapon Buff.Poison.Deadly"},
	MAGE = {"Consumable.Mage.Mana Stone"},
	HUNTER = {"Misc.Reagent.Ammo.Bullet", "Misc.Reagent.Ammo.Arrow"},
	WARRIOR = {"Misc.Reagent.Ammo.Bullet", "Misc.Reagent.Ammo.Arrow"},
}

-- Options
local options = {
    name = "RefillRemind",
    handler = RefillRemind,
    type = "group",
    args = {
		watchedItems = {
			type = "group",
			name = L["Watched items"],
			desc = L["Watched items"],
			args = {
			}
		},
		fubar = {
			type = "group",
			name = L["FuBar options"],
			desc = L["FuBar options"],
			disabled = function() return not RefillRemind.IsFuBarMinimapAttached end,
			hidden = function() return not RefillRemind.IsFuBarMinimapAttached end,
			order = 100,
			args = {
				attachMinimap = {
					type = "toggle",
					name = L["Attach to minimap"],
					desc = L["Attach to minimap"],
					get = function(info)
						return RefillRemind:IsFuBarMinimapAttached()
					end,
					set = function(info, v)
						RefillRemind:ToggleFuBarMinimapAttached()
						RefillRemind.db.char.FuBar_AttachMinimap = RefillRemind:IsFuBarMinimapAttached()
					end
				},
				hideIcon = {
					type = "toggle",
					name = L["Hide minimap/FuBar icon"],
					desc = L["Hide minimap/FuBar icon"],
					get = function(info) return RefillRemind.db.char.FuBar_HideMinimapButton end,
					set = function(info, v)
						RefillRemind.db.char.FuBar_HideMinimapButton = v
						if v then
							RefillRemind:Hide()
						else
							RefillRemind:Show()
						end
					end
				},
				showIcon = {
					type = "toggle",
					name = L["Show icon"],
					desc = L["Show icon"],
					get = function(info) return RefillRemind:IsFuBarIconShown() end,
					set = function(info, v) RefillRemind:ToggleFuBarIconShown() end
				},
				showText = {
					type = "toggle",
					name = L["Show text"],
					desc = L["Show text"],
					get = function(info) return RefillRemind:IsFuBarTextShown() end,
					set = function(info, v) RefillRemind:ToggleFuBarTextShown() end
				},
				position = {
					type = "select",
					name = L["Position"],
					desc = L["Position"],
					values = {LEFT = L["Left"], CENTER = L["Center"], RIGHT = L["Right"]},
					get = function() return RefillRemind:GetPanel() and RefillRemind:GetPanel():GetPluginSide(RefillRemind) end,
					set = function(info, val)
						if RefillRemind:GetPanel() then
							RefillRemind:GetPanel():SetPluginSide(RefillRemind, val)
						end
					end
				}
			}
		},
		options = {
			type = "group",
			name = L["Options"],
			desc = L["Options"],
			args = {
				remindOther = {
					type = "group",
					name = L["Remind me [other]"],
					desc = L["Remind me [other]"],
					inline = true,
					args = {
						remindAtVendor = {
							type = "toggle",
							name = L["At vendor which sells items on watch-list"],
							desc = L["At vendor which sells items on watch-list (only if they are below the threshold)"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.at.vendor end,
							set = function(info, v) RefillRemind.db.char.options.remind.at.vendor = v end
						},
						remindAtBank = {
							type = "toggle",
							name = L["At bank which contains items on watch-list"],
							desc = L["At bank which contains items on watch-list (only if they are below the threshold)"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.at.bank end,
							set = function(info, v) RefillRemind.db.char.options.remind.at.bank = v end
						},
						remindIfForgetToRefill = {
							type = "toggle",
							name = L["If I forgot to refill when leaving bank or vendor"],
							desc = L["If I forgot to refill when leaving bank or vendor"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.at.forgotToRefill end,
							set = function(info, v) RefillRemind.db.char.options.remind.at.forgotToRefill = v end
						},
						remindAtDropBelowThreshold = {
							type = "toggle",
							name = L["When item count drops below threshold"],
							desc = L["When item count drops below threshold (reminds only in chat and ignores 'Output remind to...' settings; not recommended if you have many watched items)"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.at.dropBelowThreshold end,
							set = function(info, v) RefillRemind.db.char.options.remind.at.dropBelowThreshold = v end
						}
					}
				},
				remindUsing = {
					type = "group",
					name = L["Output remind to"],
					desc = L["Output remind to"],
					inline = true,
					args = {
						popup = {
							type = "toggle",
							name = L["Popup"],
							desc = L["Output remind to popup"],
							get = function(info) return RefillRemind.db.char.options.remind.output.popup end,
							set = function(info, v) RefillRemind.db.char.options.remind.output.popup = v end
						},
						chat = {
							type = "toggle",
							name = L["Default chat frame"],
							desc = L["Output remind to default chat frame"],
							get = function(info) return RefillRemind.db.char.options.remind.output.chat end,
							set = function(info, v) RefillRemind.db.char.options.remind.output.chat = v end
						}
					}
				},
				zoning = {
					type = "group",
					name = L["Remind me when [zoning]"],
					desc = L["Remind me when [zoning]"],
					inline = true,
					args = {
						enteringCity = {
							type = "toggle",
							name = L["Entering major city"],
							desc = L["Entering major city"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onentering.city end,
							set = function(info, v) RefillRemind.db.char.options.remind.onentering.city = v end
						},
						leavingCity = {
							type = "toggle",
							name = L["Leaving major city"],
							desc = L["Leaving major city"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onleaving.city end,
							set = function(info, v) RefillRemind.db.char.options.remind.onleaving.city = v end
						},
						enteringResting = {
							type = "toggle",
							name = L["Entering resting area"],
							desc = L["Entering resting area (including cities)"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onentering.resting end,
							set = function(info, v) RefillRemind.db.char.options.remind.onentering.resting = v end
						},
						leavingResting = {
							type = "toggle",
							name = L["Leaving resting area"],
							desc = L["Leaving resting area (including cities)"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onleaving.resting end,
							set = function(info, v) RefillRemind.db.char.options.remind.onleaving.resting = v end
						},
						enteringInstance = {
							type = "toggle",
							name = L["Entering instance"],
							desc = L["Entering instance"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onentering.instance end,
							set = function(info, v) RefillRemind.db.char.options.remind.onentering.instance = v end
						},
						leavingInstance = {
							type = "toggle",
							name = L["Leaving instance"],
							desc = L["Leaving instance"],
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.onleaving.instance end,
							set = function(info, v) RefillRemind.db.char.options.remind.onleaving.instance = v end
						}
					}
				},
				minimumInterval = {
					type = "group",
					name = L["Minimum interval between reminds (in seconds if no unit is given)"],
					desc = L["Minimum interval between reminds (in seconds if no unit is given)"],
					inline = true,
					args = {
						global = {
							type = "range",
							name = L["Global"],
							desc = L["Global"],
							min = 5,
							max = MAX_INTERVAL,
							step = 5,
							bigStep = 5,
							get = function(info) return RefillRemind.db.char.options.remind.interval.global end,
							set = function(info, newVal) RefillRemind.db.char.options.remind.interval.global = newVal end
						},
						vendor = {
							type = "range",
							name = L["Vendor"],
							desc = L["Vendor (maybe you won't get reminded when leaving if you set this too high)"],
							min = 5,
							max = MAX_INTERVAL,
							step = 5,
							bigStep = 5,
							get = function(info) return RefillRemind.db.char.options.remind.interval.vendor end,
							set = function(info, newVal) RefillRemind.db.char.options.remind.interval.vendor = newVal end,
							disabled = function() return not RefillRemind.db.char.options.remind.at.vendor end
						},
						bank = {
							type = "range",
							name = L["Bank"],
							desc = L["Bank (maybe you won't get reminded when leaving if you set this too high)"],
							min = 5,
							max = MAX_INTERVAL,
							step = 5,
							bigStep = 5,
							get = function(info) return RefillRemind.db.char.options.remind.interval.bank end,
							set = function(info, newVal) RefillRemind.db.char.options.remind.interval.bank = newVal end,
							disabled = function() return not RefillRemind.db.char.options.remind.at.bank end
						},
						dropBelowThreshold = {
							type = "range",
							name = L["Item count drops below threshold [in minutes]"],
							desc = L["Item count drops below threshold [in minutes; per item]"],
							min = 1,
							max = 60,
							step = 5,
							bigStep = 5,
							width = "double",
							get = function(info) return RefillRemind.db.char.options.remind.interval.dropBelowThreshold end,
							set = function(info, newVal) RefillRemind.db.char.options.remind.interval.dropBelowThreshold = newVal end,
							disabled = function() return not RefillRemind.db.char.options.remind.at.dropBelowThreshold end
						},
						zoning = {
							type = "range",
							name = L["Zoning"],
							desc = L["Zoning"],
							min = 5,
							max = MAX_INTERVAL,
							step = 5,
							bigStep = 5,
							get = function(info) return RefillRemind.db.char.options.remind.interval.zoning end,
							set = function(info, newVal) RefillRemind.db.char.options.remind.interval.zoning = newVal end,
							disabled = function() return not(RefillRemind.db.char.options.remind.onentering.city or RefillRemind.db.char.options.remind.onentering.resting or RefillRemind.db.char.options.remind.onentering.instance or RefillRemind.db.char.options.remind.onleaving.city or RefillRemind.db.char.options.remind.onleaving.resting or RefillRemind.db.char.options.remind.onleaving.instance) end
						}
					}
				},
				reset = {
					type = "execute",
					name = L["Reset"],
					desc = L["Reset options to defaults"],
					confirm = true,
					func = function()
						RefillRemind.db.char.options = RefillRemind_defaults.char.options
						LibStub("AceConfigRegistry-3.0"):NotifyChange("RefillRemind")
					end
				}
			}
		}
    },
}

-- Default options (can't be local because of reset button callback)
RefillRemind_defaults = {
    char = {
        importedDefaults = false,
		gameBuild = "unknown",
		watchedItems = {},
		options = {
			remind = {
				at = {
					vendor = true,
					bank = true,
					dropBelowThreshold = false,
					forgotToRefill = true
				},
				output = {
					popup = true,
					chat = true
				},
				onentering = {
					city = true,
					resting = false,
					instance = true
				},
				onleaving = {
					city = true,
					resting = false,
					instance = false
				},
				interval = {
					global = 10,
					vendor = 15,
					bank = 15,
					zoning = 30,
					dropBelowThreshold = 15
				}
			}
		}
    }
}

local optionsFrame

function RefillRemind:OnInitialize()
	-- Called when the addon is loaded
	self:SetFuBarOption("iconPath",[[Interface\Icons\INV_Misc_Book_09]])
	self:SetFuBarOption("defaultPosition","LEFT")
	self:SetFuBarOption("hideWithoutStandby",true)
	
	self.db = LibStub("AceDB-3.0"):New("RefillRemindCharDB", RefillRemind_defaults, "char")
	if not self.db.importedDefaults then
		self.db.importedDefaults = true
		self:ImportDefaults()
	end
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RefillRemind", options)
	
	local currentBuild = strjoin(" - ", GetBuildInfo())
	if self.db.gameBuild ~= currentBuild then
		self:RefreshItemInfos(currentBuild)
	end
	
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RefillRemind", "RefillRemind")
    self:RegisterChatCommand("rr", "ChatCommand")
    self:RegisterChatCommand("refillremind", "ChatCommand")
	
	self:HookScript(InterfaceOptionsFrameAddOns, "OnShow", "InterfaceOptionsFrameAddOns_OnShow")
end

function RefillRemind:InterfaceOptionsFrameAddOns_OnShow(object)
	RefillRemind:RebuildConfig(false)
	return self.hooks[object].OnShow()
end

function RefillRemind:ImportDefaults()
	-- Import the default items for the player class
	local _, playerClass = UnitClass("player")
	local class = playerClass:lower():gsub("^%l", string.upper)
	
	local ptSet = PT:GetSetTable("Misc.Reagent.Class."..class)
	if type(ptSet) == "table" then
		for k, v in pairs(ptSet) do
			if k ~= "set" then
				self:AddItem(k, "default")
			end
		end
	end

	if type(additionalSets[playerClass]) == "table" then
		for i, v in ipairs(additionalSets[playerClass]) do
			local setTable = PT:GetSetTable(v)
			if setTable then
				for k, v in pairs(setTable) do
					self:AddItem(k, "default")
				end
			end
		end
	end
end

function RefillRemind:AddItem(itemId, entryType)
	-- Adds an item to the watched items
	
	local displayName, _, _, _, _, _, _, stackSize = GetItemInfo(itemId)
	if not displayName then
		-- Shouldn't happen!
		displayName = L["Unknown"].." "..itemId
	end
	
	if not stackSize then
		stackSize = 1
	end
	
	local threshold = stackSize
	if threshold > MAX_THRESHOLD then
		threshold = MAX_THRESHOLD
	end
	
	local newItem = {
		displayName = displayName,
		entryType = entryType,
		threshold = threshold,
		multiplyThresholdByStackSize = false,
		stackSize = stackSize,
		show = true
	}
	
	RefillRemind.db.char.watchedItems[itemId] = newItem
end

function RefillRemind:RefreshItemInfos(newBuild)
	-- Check for changes of the item info if a new WoW version is detected
	for itemId, v in pairs(RefillRemind.db.char.watchedItems) do
		local displayName, _, _, _, _, _, _, stackSize = GetItemInfo(itemId)
		if not displayName then
			-- Shouldn't happen!
			displayName = L["Unknown"].." "..itemId
		end
		
		if not stackSize then
			stackSize = 1
		end
		
		if displayName ~= v.displayName or stackSize ~= v.stackSize then
			self:Print("Updated item infos of item #" .. itemId .. ": Item name " .. v.displayName .. " => " .. displayName .. "; stack size " .. v.stackSize .. " => " .. stackSize)
			RefillRemind.db.char.watchedItems[itemId].displayName = displayName
			RefillRemind.db.char.watchedItems[itemId].stackSize = stackSize
		end
	end
	self.db.gameBuild = newBuild
end

function RefillRemind:ChatCommand(input)
	-- Handles chat commands
	if not input or input:trim() == "" then
		-- RefillRemind:RebuildConfig(false) will be called by hook
		InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
    else
        RefillRemind:RebuildConfig(false)
		LibStub("AceConfigCmd-3.0").HandleCommand(RefillRemind, "refillremind", "RefillRemind", input)
    end
end

function RefillRemind:GetItemIDFromLink(itemLink)
	if not itemLink then
		return
	end
	local found, _, itemString = string.find(itemLink, "^|c%x+|H(.+)|h%[.+%]")
	if itemString then
		local foundItemID = select(2, strsplit(":", itemString))
		if foundItemID then
			return foundItemID
		end
	end
	return nil
end

--[[===============================================
============== Main functionality stuff ==============
=================================================--]]

function RefillRemind:OnEnable()
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "OnRestingAndZoneChange")
    self:RegisterEvent("PLAYER_UPDATE_RESTING", "OnRestingAndZoneChange") -- needed for outdoor-inns
    self:RegisterEvent("MERCHANT_SHOW")
    self:RegisterEvent("MERCHANT_CLOSED")
    self:RegisterEvent("BAG_UPDATE")
    self:RegisterEvent("BANKFRAME_OPENED")
    self:RegisterEvent("BANKFRAME_CLOSED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

local lastRestingState = -1
local lastCityState = -1
local lastInstanceState = -1

function RefillRemind:OnRestingAndZoneChange()
	local restingState = IsResting()
	local cityState = Tourist:IsCity(GetZoneText()) -- Is the player in a major city?
	local instanceState = IsInInstance()
	
	if restingState ~= lastRestingState then
		if restingState then
			self:Print("Player is in a resting area now")
		else
			self:Print("Player has left resting area")
		end
	end
	
	if cityState ~= lastCityState then
		if cityState then
			self:Print("Player is in a major city now")
		else
			self:Print("Player has left major city")
		end
	end
	
	if instanceState ~= lastInstanceState then
		if instanceState then
			self:Print("Player is in an instance now")
		else
			self:Print("Player has left instance")
		end
	end
	
	lastRestingState = restingState
	lastCityState = cityState
	lastInstanceState = instanceState
end

function RefillRemind:PLAYER_ENTERING_WORLD()
	RefillRemind:UnregisterEvent("PLAYER_ENTERING_WORLD")
	RefillRemind:OnRestingAndZoneChange()
end

function RefillRemind:MERCHANT_SHOW()
	--self:Print("Player is at merchant now")
	if not RefillRemind.db.char.options.remind.at.vendor then
		return
	end
	
	for i = 1, GetMerchantNumItems() do
		local itemLink = GetMerchantItemLink(i)
		local itemId = RefillRemind:GetItemIDFromLink(itemLink)
		if itemId and RefillRemind.db.char.watchedItems[itemId] then
			self:Print("This vendor sells " .. itemLink)
		end
	end
end

function RefillRemind:MERCHANT_CLOSED()
	--self:Print("Player is not at merchant now")
	if not RefillRemind.db.char.options.remind.at.vendor or not RefillRemind.db.char.options.remind.at.forgotToRefill then
		return
	end
end

function RefillRemind:BANKFRAME_OPENED()
	--self:Print("Player is at bank now")
	if not RefillRemind.db.char.options.remind.at.bank then
		return
	end
	
	for itemId, v in pairs(RefillRemind.db.char.watchedItems) do
		local itemCountAtBank = GetItemCount(itemId, true) - GetItemCount(itemId)
		if itemCountAtBank > 0 then
			self:Print("Bank contains " .. v.displayName)
		end
	end
end

function RefillRemind:BANKFRAME_CLOSED()
	--self:Print("Player has left bank")
	if not RefillRemind.db.char.options.remind.at.bank or not RefillRemind.db.char.options.remind.at.forgotToRefill then
		return
	end
end

function RefillRemind:BAG_UPDATE()
	if not RefillRemind.db.char.options.remind.at.dropBelowThreshold then
		return
	end
end

function RefillRemind:OnDisable()
    -- Nothing to do here - events are de-registered by Ace3
end

--[[===============================================
=================== Config stuff ===================
=================================================--]]
StaticPopupDialogs["RefillRemind_BadItem"] = {
	text = L["Unknown item."],
	button1 = OKAY,
	showAlert = 1,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}

StaticPopupDialogs["RefillRemind_AskItemName"] = {
	text = L["Please input the name or the ItemID of the item you want to add (using ItemID could cause connection aborts)"],
	button1 = OKAY,
	button2 = CANCEL,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetText("")
	end,
	OnAccept = function()
		local input = getglobal(this:GetParent():GetName().."EditBox"):GetText()
		local itemId = tonumber(input)
		if itemId then
			-- Check ItemID
			local displayName = GetItemInfo(input)
			if displayName then
				RefillRemind:AddItem(itemId, "custom")
				RefillRemind:RebuildConfig(true)
				return false
			else
				StaticPopup_Show("RefillRemind_BadItem")
				return true
			end
		else
			-- Check ItemName
			local itemNameOkay = false
			local itemLink = select(2, GetItemInfo(input))
			if itemLink then
				local foundItemID = RefillRemind:GetItemIDFromLink(itemLink)
				if foundItemID then
					itemId = foundItemID
					itemNameOkay = true
				end
			end
			-- And add if okay
			if itemNameOkay then
				RefillRemind:AddItem(itemId, "custom")
				RefillRemind:RebuildConfig(true)
				return false
			else
				StaticPopup_Show("RefillRemind_BadItem")
				return true
			end
		end
	end,
	hasEditBox = 1,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
};

function RefillRemind:RebuildConfig(refreshConfigWindow)
	-- Rebuilds the config submenus
	options.args.watchedItems.args = {
		removeAll = {
			type = "execute",
			name = L["Remove all"],
			desc = L["Remove all"],
			confirm = true,
			func = function()
				RefillRemind.db.char.watchedItems = {}
				RefillRemind:RebuildConfig(true)
			end
		},
		addNew = {
			type = "execute",
			name = L["Add new item"],
			desc = L["Add new item"],
			--input = true, -- allowed (according docu) but throws error!?
			func = function()
				StaticPopup_Show ("RefillRemind_AskItemName");
			end
		},
		importDefault = {
			type = "execute",
			name = L["Import default items"],
			desc = L["Import default items"],
			confirm = true,
			func = function()
				RefillRemind:ImportDefaults()
				RefillRemind:RebuildConfig(true)
			end
		}
	}
	
	-- Add submenu for every watched item
	for itemId, v in pairs(RefillRemind.db.char.watchedItems) do
		options.args.watchedItems.args["item"..itemId] = {
			type = "group",
			name = v.displayName,
			desc = v.displayName,
			args = {
				show = {
					type = "toggle",
					name = L["Show in FuBar tooltip"],
					desc = L["Show in FuBar tooltip"],
					get = function(info) return RefillRemind.db.char.watchedItems[itemId].show end,
					set = function(info, newVal) RefillRemind.db.char.watchedItems[itemId].show = newVal end
				},
				threshold = {
					type = "range",
					name = L["Threshold"],
					desc = L["Minimum item count. If you have less pieces (than this value) of that item in your bags you will be reminded to refill. Set this to 0 if you don't want to be reminded to refill that item."],
					min = 0,
					max = MAX_THRESHOLD,
					get = function(info) return RefillRemind.db.char.watchedItems[itemId].threshold end,
					set = function(info, newVal) RefillRemind.db.char.watchedItems[itemId].threshold = newVal end
				},
				multiplyThresholdByStackSize = {
					type = "toggle",
					name = L["Multiply threshold by stack size"],
					desc = L["Multiply threshold by stack size"],
					width = "double",
					get = function(info) return RefillRemind.db.char.watchedItems[itemId].multiplyThresholdByStackSize end,
					set = function(info, newVal) RefillRemind.db.char.watchedItems[itemId].multiplyThresholdByStackSize = newVal end
				},
				multiplyThresholdByStackSizeInfo = {
					type = "description",
					name = L["Current stack size of that item"] .. ": " .. v.stackSize;
				},
				delete = {
					type = "execute",
					name = L["Remove"],
					desc = L["Remove"],
					func = function()
						RefillRemind.db.char.watchedItems[itemId] = nil
						RefillRemind:RebuildConfig(true)
					end
				}
			}
		}
	end
	
	if refreshConfigWindow then
		LibStub("AceConfigRegistry-3.0"):NotifyChange("RefillRemind")
	end
end

--[[===============================================
=================== FuBar stuff ===================
=================================================--]]

function RefillRemind:OpenMenu()
	self:ChatCommand("")
end

function RefillRemind:OnUpdateFuBarText()
	RefillRemind:SetFuBarText("RR")
end

function RefillRemind:OnUpdateFuBarTooltip()
	GameTooltip:ClearLines()
	GameTooltip:AddLine("|cffffff00"..L["RefillRemind"].."|r")
	GameTooltip:AddLine(L["|cffffff00Right-click|r to open the Configuration GUI"])
	
	for itemId, v in pairs(RefillRemind.db.char.watchedItems) do
		if v.show then
			local itemCount = GetItemCount(itemId)
			GameTooltip:AddLine(itemCount .. " x " .. v.displayName)
		end
	end
end
